//******************************************************************************
//
//   ..........:klav.c
//
//   ()......:Rubel
//
//   ()...:PIC24FJ64GA002 (20  . ; : 	_CONFIG1(0x3F7F);
//																															_CONFIG2(0x7A9A); 
//	 ....:MPLAB C COMPILER FOR PIC24 MCUs AND dsPIC DSCs v
//
//   ......:-
//
//   ........:-
//
//   ..........:-
//
//******************************************************************************

#include "p24FJ64GA002.h"
#include "klav.h"
#include <timer.h>
#include <uart.h> 

// 
_CONFIG1(0x3F7F);				
//_CONFIG2(0x799B);			//. 8*4PLL=32; Fosc=32; Fcy=16;
//_CONFIG2(0x7B9A);			//. 8 *4PLL = 32 
_CONFIG2(0x7A9A);				//. 20  
												//Fosc = 20; Fcy = 10;		
/************************************************************************
*
*     : main
*
*    :  -
*
*     :  -
*
*   :     
*
************************************************************************/

int main (VOID)
{ 	
	RCONbits.SWDTEN = 0;		// WDT
	CLKDIVbits.RCDIV  = 0;	//   "0"(8M);
													//Fosc=8*4PLL=32; Fcy=Fosc/2=16;
	RCONbits.SWDTEN = 0;		// WDT											
	AD1PCFG = 0xFFFF;				//.  																
	portinit64002();				// 		
	//pinmapconfig();					// 
	
	//!!!!       CNEN2!!!!!
	CNconfig64002();				//  CN
	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	
	//UART1init();						//57600	
	init_module();
	
	IEC1bits.CNIE = 1;		  //. CN	
	while(1) 							
	{ 
		while(!IFS1bits.CNIF);//    
		
		//   
		nop();
		//  UART  
		nop();
		//   CN     . 
		IFS1bits.CNIF = 0;
		IEC1bits.CNIE = 1;		  //. CN		
	}
}
	
/************************************************************************
*
*     : portinit64002
*
*    :  -
*
*     :  -
*
*   :    -
*
************************************************************************/
void portinit64002(void) 
{
	//A  =***********43210=  	"*" -  	
	PORTA = 0b0000000000000000;  	//.
	TRISA = 0b1111111111111110; 	//"1"=	RA0 - 
  //ODCA  = 0b0000000000000000; //"1"= 
  
	//  =FEDCBA9876543210=
	PORTB = 0b0000000000000000;		//.
	TRISB = 0b1111111111111111; 	//"1"=
  //ODCB  = 0b0000000000000000;	//"1"= 
}

/***********************************************************************
*
*     : pinmapconfig
*
*    :  -
*
*     :  -
*							 
*   :    . 
*
**************************************************************/
void pinmapconfig(void)	
{
	//   : (OSCCON<6> = 1)
	OSCCON &= 0x0046;
	OSCCON &= 0x0057;
	OSCCONbits.IOLOCK = 1;
		
	//   :	
	//  SDO1   RP5:
	RPOR2bits.RP5R = 7;	
	//   SCK1OUT   PR4:		
	RPOR3bits.RP6R = 8;

	//   : (OSCCON<6> = 0)
	OSCCON &= 0x0046;
	OSCCON &= 0x0057;
	OSCCONbits.IOLOCK = 0;
}


/************************************************************************
*
*     : UART1init
*
*    	:  -
*
*     	:  -
*
*   	:    UART1
*
************************************************************************/
void UART1init(void)
{		
	// U1MODE
	U1MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U1MODEbits.USIDL 	= 0;	// Bit13 Continue in Idle
	U1MODEbits.IREN 	= 0;	// Bit12 No IR translation
	U1MODEbits.RTSMD 	= 0;	// Bit11 Simplex Mode
	U1MODEbits.UEN 		= 0;	// Bits8,9 TX,RX enabled, CTS,RTS not
	U1MODEbits.WAKE 	= 0;	// Bit7 No Wake up (since we don't sleep here)
	U1MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U1MODEbits.ABAUD 	= 0;	// Bit5 No Autobaud (would require sending '55')
	U1MODEbits.RXINV 	= 0;	// Bit4 IdleState = 1
	U1MODEbits.BRGH 	= 1;	// Bit3 16 clocks per bit period
	U1MODEbits.PDSEL 	= 0;	// Bits1,2 8bit, No Parity
	U1MODEbits.STSEL 	= 0;	// Bit0 One Stop Bit
	
	U2BRG = 42;			// baud rate 57600

	// Load all values in for U1STA SFR
	U1STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred (1/2 config!)
	U1STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U1STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U1STAbits.UTXBRK = 0;	//Bit11 Disabled
	U1STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U1STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U1STAbits.TRMT = 0;		//Bit8 *Read Only bit*
	U1STAbits.URXISEL = 0;	//Bits6,7 Int. on character recieved
	U2STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U1STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U1STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U1STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U1STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U1STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	IFS1bits.U2TXIF = 0;	// Clear the Transmit Interrupt Flag
	IEC1bits.U2TXIE = 1;	// Enable Transmit Interrupts
	IFS1bits.U2RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC1bits.U2RXIE = 1;	// Enable Recieve Interrupts

	U1MODEbits.UARTEN = 1;	// And turn the peripheral on

	U1STAbits.UTXEN 	= 1;
}

/************************************************************************
*
*     : CNconfig64002
*
*     :  -
*
*      :  -
*							 
*     :    IO   (CN)  PIC24FJ64GA004  
*
************************************************************************/
void CNconfig64002(void)
{	
	// CN
	//RP    =FEDCBA9876543210=
	CNEN1 = 0b0000000000000011;
	//       =*EDCBA9876543210=   "*" - 
	CNEN2 = 0b1111111111111111;
	
	/*
	// 
	//RP    =FEDCBA9876543210= 
	CNPU1 = 0b0000100000000011;
	//       =*EDCBA9876543210=   "*" - 
	CNPU2 = 0b0000100000000000;
	*/
	
	IFS1bits.CNIF = 0;		 		//  
	IPC4bits.CNIP = 7;		 		//  = 6	
	//IEC1bits.CNIE = 1;		 		//. CN
} 

/************************************************************************
*
*     : _ISR _CNInterrupt
*
*    :  -
*
*     :  -
*
*   :       N
*
************************************************************************/
void __attribute__((interrupt,no_auto_psv)) _CNInterrupt(void)
{	
	IEC1bits.CNIE = 0;		  //. CN
	// 30 
	Delay_ms(30); 
	
	//     
	scankeypad();
	
	//  
	//IFS1bits.CNIF = 0; 
}

/************************************************************************
*
*     : scankeypad
*
*    	:  unsigned char -     "0"     
*
*     	:  -
*
*   	:   
*
************************************************************************/
void scankeypad(void)
{ 
	char row;  		//c 
	char column;	// 
	
	T = PORTB;    //   
		
  for (row=0; row<NUM_ROW; row++) //  
  { 
	  //     ."1"
	  PORTB |= MASK_STR;
	  
	  //      "0"	
	  switch(row)
		{
		  case 0:
		  	ROW1 = 0;		  
		  case 1:
		  	ROW2 = 0;
		  case 2:
		  	ROW3 = 0;
		  case 3:
		  	ROW4 = 0;
		 	case 4:
		 		ROW5 = 0;
		  case 5:
		  	ROW6 = 0;
		}		       
	  
	  // 100    	
	  Delay_us(100);			 		
			
    //  
    for (column=0; column<NUM_COLUMN; column++)
    {
	    switch(column)
	    {
		   	case 0:
		   	{
		   		mass_klav[row][column] = COL1;
		   	}break;	
		   	case 1:
		   	{
		   		mass_klav[row][column] = COL2;
		   	}break;
		   	case 2:
		   	{ 
		   	  mass_klav[row][column] = COL3;
		   	}break;  
		  }	      
		}
		
		//     ."0"
	  PORTB &= (~MASK_STR);
  } 
}//*/


/************************************************************************
*
*     :  module_init
*
*    	:  - 
*
*     	:  -
*
*   	:    
*
************************************************************************/
void init_module(void)
{	
	//     	
	//    :
	COL1_IN_OUT = IN;
	COL2_IN_OUT = IN;	
	COL3_IN_OUT = IN;
	
	/*   
	COL1_CNPU = ON;
	COL2_CNPU = ON;
	COL3_CNPU = ON;	
	*/
	
	//    :
	ROW1_IN_OUT = OUT;
	ROW2_IN_OUT = OUT;
	ROW3_IN_OUT = OUT;
	ROW4_IN_OUT = OUT;
	ROW5_IN_OUT = OUT;
	ROW6_IN_OUT = OUT;
	
	//    "0"
	ROW1 = 0;
	ROW2 = 0;
	ROW3 = 0;
	ROW4 = 0;
	ROW5 = 0;
	ROW6 = 0;
	
	// :
	BUZ = 0;
		
}



 




